
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "defines.h"

#include "parse.h"
#include "pass_1.h"
#include "stack.h"


int i_b1 = 0, i_b2 = 0, i_e1 = 0, i_e2 = 0, input_number_error_msg = 0, ss, string_size, flo_l, flo_h;
char label[256], xyz[256];
char unevaluated_expression[256];
double f;

extern int i, size, d, error_level, macro_active;
extern char *buffer, tmp[256], cp[256];
extern struct active_file_info *active_file_info_first, *active_file_info_last, *active_file_info_tmp;
extern struct gba_def *defines, *tmp_def, *next_def;
extern struct gba_macro *macros_current;



int compare_next_token(char *in, int s) {

  int a, t;
  char e;



  a = i;
  for (e = buffer[a]; e == ' ' || e == ',' || e == 0x0A; e = buffer[++a]);

  if (macro_active != 0 && e == '\\') {

    int d, k;


    d = 0;
    for (k = 0; k < 16; k++, d *= 10) {
      e = buffer[++a];
      if (e >= '0' && e <= '9')
	d += e - '0';
      else {
	a--;
	break;
      }
    }

    d /= 10;
    if (d > macros_current->supplied_arguments) {
      if (input_number_error_msg == 0) {
	sprintf(xyz, "COMPARE_NEXT_SYMBOL: Macro \"%s\" wasn't called with enough arguments.\n", macros_current->name);
	pass_1_print_error(xyz, ERROR_NONE);
      }
      return FAILED;
    }

    a = macros_current->arguments_start[d - 1];

    e = buffer[a];
    for (t = 0; t < s && e != ' ' && e != ',' && e != 0x0A; ) {
      if (in[t++] != e)
      return FAILED;
      e = buffer[++a];
    }
  }
  /* not in MACRO mode */
  else {
    for (t = 0; t < s && e != ' ' && e != ',' && e != 0x0A; ) {
      if (in[t++] != e)
	return FAILED;
      e = buffer[++a];
    }
  }

  if (t == s)
    return SUCCEEDED;
  else
    return FAILED;
}


int input_number(void) {

  unsigned char e, ee;
  int k, p, s;



  for (e = buffer[i++]; e == ' ' || e == ','; e = buffer[i++]);

  if (e == 0x0A)
    return INPUT_NUMBER_EOL;

  /* check the type of the expression */
  p = i;
  ee = e;
  while (ee != 0x0A) {
    /* string / symbol -> no calculating */
    if (ee == '"' || ee == ',' || (ee == '>' && buffer[p] != '>') || (ee == '<' && buffer[p] != '<') || (ee == '=' && buffer[p] == '=') ||
	(ee == '!' && buffer[p] == '='))
      break;
    if (ee == '-' || ee == '+' || ee == '*' || ee == '/' || ee == '&' || ee == '|' || ee == '^' ||
	(ee == '<' && buffer[p] == '<') || (ee == '>' && buffer[p] == '>') || ee == '#') {
      /* launch stack calculator */
      if ((p = stack_calculate(&buffer[i - 1], &d)) == STACK_CALCULATE_DELAY)
	break;
      else
	return p;
    }
    ee = buffer[p];
    p++;
  }

  /* MACRO */
  if (macro_active != 0 && e == '\\') {
    if (buffer[i] == '@') {
      i++;
      d = macros_current->calls - 1;
      return SUCCEEDED;
    }

    for (d = 0, k = 0; k < 4; k++) {
      e = buffer[i++];
      if (e >= '0' && e <= '9')
	d = (d * 10) + (e - '0');
      else {
	i--;
	break;
      }
    }

    if (d > macros_current->supplied_arguments) {
      if (input_number_error_msg == 0) {
	sprintf(xyz, "Macro \"%s\" wasn't called with enough arguments.\n", macros_current->name);
	pass_1_print_error(xyz, ERROR_NUM);
      }
      return FAILED;
    }

    p = i;
    i = macros_current->arguments_start[d - 1];
    /* read the argument */
    k = input_number();
    i = p;
    return k;
  }

  if (e >= '0' && e <= '9') {
    d = (e - '0') * 10;
    s = 0; /* integer */
    for (k = 0; k < 16; k++, d *= 10, i++) {
      e = buffer[i];
      if (e >= '0' && e <= '9') {
	if (s != 0) {
	  flo_l *= 10;
	  flo_l += e - '0';
	}
	d += e - '0';
      }
      else if (e == '.') {
	s = k + 1; /* float */
	d /= 10;
	flo_h = d;
	flo_l = 0;
      }
      else
	break;
    }

    d /= 10;

    if (s != 0) {
      for (f = d, p = 0; p < k - s; p++)
	f /= 10;

      return INPUT_NUMBER_FLOAT;
    }

#ifndef W65816
    if (d < -32768 || d > 65535) {
      pass_1_print_error("Out of 16bit range.\n", ERROR_NUM);
      return FAILED;
    }
#else
    if (d < -8388608 || d > 16777215) {
      pass_1_print_error("Out of 24bit range.\n", ERROR_NUM);
      return FAILED;
    }
#endif

    return SUCCEEDED;
  }

  if (e == '$') {
    d = 0;
    for (k = 0; k < 16; k++, i++) {
      e = buffer[i];
      if (e >= '0' && e <= '9') {
	d = d << 4;
	d += e - '0';
      }
      else if (e >= 'A' && e <= 'F') {
	d = d << 4;
	d += e - 'A' + 10;
      }
      else if (e >= 'a' && e <= 'f') {
	d = d << 4;
	d += e - 'a' + 10;
      }
      else
	break;
    }

#ifndef W65816
    if (d < -32768 || d > 65535) {
      pass_1_print_error("Out of 16bit range.\n", ERROR_NUM);
      return FAILED;
    }
#else
    if (d < -8388608 || d > 16777215) {
      pass_1_print_error("Out of 24bit range.\n", ERROR_NUM);
      return FAILED;
    }
#endif

    return SUCCEEDED;
  }

  if (e == '%') {
    d = 0;
    for (k = 0; k < 32; k++, i++) {
      e = buffer[i];
      if (e == '0' || e == '1') {
	d = d << 1;
	d += e - '0';
      }
      else
	break;
    }

#ifndef W65816
    if (d < -32768 || d > 65535) {
      pass_1_print_error("Out of 16bit range.\n", ERROR_NUM);
      return FAILED;
    }
#else
    if (d < -8388608 || d > 16777215) {
      pass_1_print_error("Out of 24bit range.\n", ERROR_NUM);
      return FAILED;
    }
#endif

    return SUCCEEDED;
  }

  if (e == '\'') {
    d = buffer[i++];
    e = buffer[i];
    if (e != '\'') {
      if (input_number_error_msg == 0) {
	sprintf(xyz, "Got '%c' (%d) when expected \"'\".\n", e, e);
	pass_1_print_error(xyz, ERROR_NUM);
      }
      return FAILED;
    }
    i++;

    return SUCCEEDED;
  }

  if (e == '"') {

    for (k = 0; k < MAX_NAME_LENGTH - 1; ) {
      e = buffer[i++];

      if (e == '\\' && buffer[i] == '"') {
	label[k++] = '"';
	i++;
	continue;
      }

      if (e == '"')
	break;

      if (macro_active != 0 && e == '\\') {

	e = buffer[i++];

	if (e == '"') {
	  label[k++] = e;
	  continue;
	}

	if (e == '\\') {
	  label[k++] = e;
	  continue;
	}

	if (e == '@') {
	  sprintf(xyz, "%d%c", macros_current->calls - 1, 0);
	  strcpy(&label[k], xyz);
	  k += strlen(xyz);
	  continue;
	}

	label[k++] = '\\';
	label[k++] = e;
	continue;
      }

      if (e == 0 || e == 0x0A) {
	pass_1_print_error("String wasn't terminated properly.\n", ERROR_NUM);
	return FAILED;
      }

      label[k++] = e;
    }

    if (k == MAX_NAME_LENGTH - 1) {
      if (input_number_error_msg == 0)
	pass_1_print_error("The string is too long (max 127 bytes).\n", ERROR_NUM);
      return FAILED;
    }

    label[k] = 0;
    string_size = k;
    return INPUT_NUMBER_STRING;
  }

  /* last choice is a label */
  label[0] = e;
  for (k = 1; k < MAX_NAME_LENGTH - 1; k++) {
    e = buffer[i++];
    if (e == 0x0A || e == ')' || e == ',' || e == ']') {
      i--;
      break;
    }
    else if (e == ' ')
      break;
    label[k] = e;
  }

  if (k == MAX_NAME_LENGTH - 1) {
    if (input_number_error_msg == 0)
      pass_1_print_error("The label is too long (max 127 bytes).\n", ERROR_NUM);
    return FAILED;
  }

  label[k] = 0;

  /* check if the label is actually a definition */
  tmp_def = defines;
  while (tmp_def != NULL) {
    if (strcmp(label, tmp_def->alias) == 0) {
      if (tmp_def->type == DEFINITION_TYPE_VALUE) {
	d = tmp_def->value;
	return SUCCEEDED;
      }
      else {
	string_size = tmp_def->size;
	memcpy(label, tmp_def->string, string_size);
	label[string_size] = 0;
	return INPUT_NUMBER_STRING;
      }
    }
    tmp_def = tmp_def->next;
  }

  /* check out for \@-symbols */
  if (macro_active != 0) {
    if (label[k - 2] == '\\' && label[k - 1] == '@')
      sprintf(&label[k - 2], "%d%c", macros_current->calls - 1, 0);
  }

  return INPUT_NUMBER_ADDRESS_LABEL;
}


int get_next_token(void) {

  while (1) {
    for ( ; buffer[i] == ' '; i++);
    if (i == size)
      break;
    if (buffer[i] == 0x0A) {
      i++;
      if (error_level == ERROR_LEVEL_MAX)
	next_line();
      continue;
    }
    else
      break;
  }

  i_b2 = i_b1;
  i_b1 = i;

  if (buffer[i] == '"') {
    if (macro_active == 0) {
      for (ss = 0, i++; buffer[i] != 0x0A && buffer[i] != '"'; ) {
	if (buffer[i] == '\\' && buffer[i + 1] == '"') {
	  tmp[ss++] = '"';
	  i += 2;
	}
	else
	  tmp[ss++] = buffer[i++];
      }
    }
    else {
      ss = 0;
      while (1) {
	for (i++; buffer[i] != 0x0A && buffer[i] != '"' && buffer[i] != '\\'; tmp[ss++] = buffer[i++]);
	if (buffer[i] == 0x0A || buffer[i] == '"')
	  break;

	if (buffer[i] == '\\') {
	  char e;

	  i++;
	  e = buffer[i];

	  if (e == '"') {
	    tmp[ss++] = '"';
	    continue;
	  }

	  if (e != '\\') {
	    if (e == '@') {
	      sprintf(xyz, "%d%c", macros_current->calls - 1, 0);
	      strcpy(&tmp[ss], xyz);
	      ss += strlen(xyz);
	      continue;
	    }
	    else {
	      tmp[ss++] = '\\';
	      tmp[ss++] = e;
	    }
	  }
	  else
	    tmp[ss++] = e;
	}
      }
    }

    if (buffer[i] == 0x0A) {
      pass_1_print_error("GET_NEXT_TOKEN: String wasn't terminated properly.\n", ERROR_NONE);
      return FAILED;
    }
    tmp[ss] = 0;
    i++;
    i_e2 = i_e1;
    i_e1 = i;

    return GET_NEXT_TOKEN_STRING;
  }

  if (buffer[i] == '.') {
    tmp[0] = '.';
    i++;
    for (ss = 1; buffer[i] != 0x0A && buffer[i] != ' ' && ss <= MAX_NAME_LENGTH; ) {
      tmp[ss] = buffer[i];
      cp[ss - 1] = toupper((int)buffer[i]);
      i++;
      ss++;
    }
    cp[ss - 1] = 0;
  }
  else {
    for (ss = 0; buffer[i] != 0x0A && buffer[i] != ' ' && ss <= MAX_NAME_LENGTH; tmp[ss++] = buffer[i++]);
  }

  if (ss > MAX_NAME_LENGTH) {
    pass_1_print_error("GET_NEXT_TOKEN: Too long for a token.\n", ERROR_NONE);
    return FAILED;
  }

  tmp[ss] = 0;
  i_e2 = i_e1;
  i_e1 = i;

  if (macro_active != 0 && tmp[0] == '\\') {

    int k, e, p, d;


    d = 0;
    for (k = 0; k < 16; k++) {
      e = tmp[k + 1];
      if (e >= '0' && e <= '9') {
	d *= 10;
	d += e - '0';
      }
      else
	break;
    }

    if (d > macros_current->supplied_arguments) {
      if (input_number_error_msg == 0) {
	sprintf(xyz, "GET_NEXT_TOKEN: Macro \"%s\" wasn't called with enough arguments.\n", macros_current->name);
	pass_1_print_error(xyz, ERROR_NONE);
      }
      return FAILED;
    }

    p = i;
    i = macros_current->arguments_start[d - 1];
    /* read the argument */
    k = get_next_token();
    i = p;
    return k;
  }

  return SUCCEEDED;
}


int skip_next_token(void) {

  for ( ; buffer[i] == ' ' || buffer[i] == ','; i++);

  if (buffer[i] == 0x0A)
    return FAILED;

  i_b2 = i_b1;
  i_b1 = i;

  if (buffer[i] == '"') {
    for (i++; buffer[i] != 0x0A && buffer[i] != '"'; i++);
    if (buffer[i] == 0x0A) {
      pass_1_print_error("PASS_NEXT_TOKEN: String wasn't terminated properly.\n", ERROR_NONE);
      return FAILED;
    }
    i++;
    i_e2 = i_e1;
    i_e1 = i;

    return SUCCEEDED;
  }

  for (; buffer[i] != 0x0A && buffer[i] != ' ' && buffer[i] != ','; i++);

  i_e2 = i_e1;
  i_e1 = i;

  return SUCCEEDED;
}
